# -*- perl -*-
#
# Copyright (C) 1996 Ken MacLeod
# See the file COPYING for distribution terms.
#

# XXX needs to be brought into modern times

use strict;

package Text::GDO::toDump;

package Text::GDO::DocObject;

sub ToDump {
    my ($self) = @_;

    $self->dump_to (0);
}

sub dump_to {
    my ($self, $depth) = @_;
    my ($block);

    print "-- " . " " x $depth . (ref $self) . "::content --\n";
    foreach $block (@{$self->{content}}) {
	$block->dump_to($depth+1);
    }
}

package Text::GDO::Document;

sub dump_to {
    my ($self, $depth) = @_;
    my ($block);

    print "-- Document::Title --\n";
    $self->{'title'}->dump_to($depth+1);
    print "-- Document::Abstract --\n";
    $self->{'abstract'}->dump_to($depth+1);
    print "-- Document::Copyright --\n";
    $self->{'copyright'}->dump_to($depth+1);
    print "-- Document::Content --\n";
    foreach $block (@{$self->{'content'}}) {
	$block->dump_to ($depth+1);
    }
}

package Text::GDO::Data;

sub dump_to {
    my ($self, $depth) = @_;
    my ($event);

    print "-- " . " " x $depth . "Data --\n";
    print $self->{'source'}->as_string (new Text::GDO::Context) . "\n";
}

package Text::GDO::List;

sub dump_to {
    my ($self, $depth) = @_;
    my ($item);

    print "-- " . " " x $depth . "List::Type --\n";
    print $self->{type} . "\n";
    foreach $item (@{$self->{content}}) {
	$item->dump_to($depth+1);
    }
}

package Text::GDO::Section;

sub dump_to {
    my ($self, $depth) = @_;
    my ($block);

    print "-- Section::Title --\n";
    $self->{'title'}->dump_to($depth+1);
    print "-- Section::Content --\n";
    foreach $block (@{$self->{content}}) {
	$block->dump_to ($depth+1);
    }
}

package Text::GDO::Formal;

sub dump_to {
    my ($self, $depth) = @_;
    my ($block);

    print "-- Formal::Title --\n";
    $self->{'title'}->dump_to($depth+1);
    print "-- Formal::Content --\n";
    foreach $block (@{$self->{content}}) {
	$block->dump_to ($depth+1);
    }
}

package Text::GDO::Admonition;

sub dump_to {
    my ($self, $depth) = @_;
    my ($block);

    print "-- Admonition::Title --\n";
    $self->{'title'}->dump_to($depth+1);
    print "-- Admonition::Content --\n";
    foreach $block (@{$self->{content}}) {
	$block->dump_to ($depth+1);
    }
}

1;
