<!-- -*- sgml -*- -->
<!DOCTYPE spec PUBLIC "-//Ken MacLeod//DTD GSF Spec//EN">
<spec>
  <head></head>
  
  <rules>
    <rule><query/SPAPER SMEMO SLETTER/           <isa/Document/
    <rule><query/PAPERFRONT/ <isa/Holder/
      <rules>
	<rule><query/TITLE/ <save/{title}/
	  <!-- XXX AUTHOR is not being properly mapped to Author/vCard -->
	<rule><query/AUTHOR/  <isa/Holder/
	  <rules>
	    <rule><query/NAME/ <isa/Author/
	      <push/{authors}/
	    <rule><query/ADDRESS/ <isa/Block/
	      <push/{addresses}/
	    <rule><query/ORG/ <save/{orgname}/
	  </rules>
	<rule><query/DATE/ <save/{date}/
	<rule><query/COPYRITE/ <save/{copyright}/
	<rule><query/ABSTRACT/ <save/{abstract}/
      </rules>
    </rule>

    <rule><query/BODY/ <isa/Holder/

    <rule><query/APPENDIX/ <isa/Section/
    <rule><query/H1 H2 H3 H4/ <isa/Section/
    <rule><query/H1T H2T H3T H4T/ <save/{title}/

    <rule><query/NOPRINT/ <isa/Holder/
    <rule><query/P/ <isa/Paragraph/
    <rule><query/LINE/ <isa/Line/
    <rule><query/ALINE/ <isa/Line/

    <rule><query/OL/ <isa/List ('type' => 'ordered')/
    <rule><query/UL/ <isa/List ('type' => 'itemized')/
    <rule><query/TL/ <isa/List ('type' => 'variable')/
    <rule><query/TLI/ <isa/Holder/
    <rule><query/TLIT/ <isa/ListTerm/
    <rule><query/TLID/ <isa/ListItem/
    <rule><query/LI/ <isa/ListItem/

    <rule><query/CODE-LINES/ <isa/Screen/
    <rule><query/TEXEQN-DISPLAY/ <isa/Screen/
    <rule><query/LISTING/ <isa/Screen/
    <rule><query/FIG/ <isa/Formal ('type' => 'Figure')/
    <rule><query/FIGCAP/ <save/{title}/

    <rule><query/HDREF/ <isa>XRefEnd ('link' => <attr/REFID/)</isa>
    <rule><query/FIGREF/ <isa>XRefEnd ('link' => <attr/REFID/)</isa>
    <rule><query/FNREF/ <isa>XRefEnd ('link' => <attr/REFID/)</isa>
    <rule><query/LIREF/ <isa>XRefEnd ('link' => <attr/REFID/)</isa>
    <rule><query/URI/ <isa/URL/

    <rule><query/Q/ <isa/Inline_Quote/
    <rule><query/CODE/ <isa/Inline_Literal/
    <rule><query/EMPH/ <isa/Inline_Emphasis/
    <rule><query/TEXEQN/ <isa/Inline/
    <rule><query/HP0/ <isa/Inline/
    <rule><query/HP1/ <isa/Inline/
    <rule><query/HP2/ <isa/Inline/
    <rule><query/HP3/ <isa/Inline/
    <rule><query/FILE/ <isa/Inline_Literal/
    <rule><query/DNS/ <isa/Inline_Literal/
    <rule><query/MBOX/ <isa/Inline_Literal/
    <rule><query/ATTR/ <isa/Inline_Literal/
    <rule><query/TAG/ <isa/Snafu_SGMLTag/
  </rules>

  <stuff>
sub save_attr {
    my ($self, $data, $event) = @_;
    my ($parent) = $data->{'diversion'}[-1];
    my ($id, $id_type, $id_attr);

    if ($id_attr = $event->data->attribute ('ID')) {
        $id_type = $id_attr->type;
        if ($id_type ne 'IMPLIED') {
            $id = $id_attr->value;
            $parent->{'id'} = $id;
            new Text::GDO::Reference ($data, 'object' => $parent, 'id' => $id);
        }
    }
}
package Text::GDO::Snafu_SGMLTag;
@Text::GDO::Snafu_SGMLTag::ISA = qw{Text::GDO::Inline};

sub as_string {
    my ($self, $context) = @_;

    return "<" . $self->{'source'}->as_string($context) . ">";
}

</stuff>
</spec>