#! @PERL5@
#
# Copyright (C) 1996 Ken MacLeod
# See the file COPYING for distribution terms.
#

use Text::GDO;
use FileHandle;
require "getopts.pl";

($prog = $0) =~ s|.*/||;

$usage = "usage: $prog [-O OUTPUTTYPE] [-L LIBDIRS] [-o OUTPUTFILE] [file]\n"
    .    "   OUTPUTYPE  :=  OUTPUTSPEC [ \`,' OUTPUTSPEC [...]]\n"
    .    "   OUTPUTSPEC :=  TYPE[ \`(' OPTION [ \`;' OPTION [...] \`)' ]\n"
    .    "   OPTION     :=  \`no'KEY\n"
    .    "                or KEY\n"
    .    "                or KEY=VALUE\n"
    .    "example:  $prog -O \"Ascii(nopref_undertitle;pref_block=left),HTML\" doc/readme\n"
    .    "  (yes, I will be working on a much simpler way to pass options :-)\n";

&Getopts ('O:L:o:');

$output_type = $opt_O ? $opt_O : "Ascii";
$output_file = $opt_o;
$addl_libs = $opt_L;

if ($#ARGV == -1) {
    $file = "stdin";
} elsif ($#ARGV == 0) {
    $file = $ARGV[0];
} else {
    die $usage;
}

Text::GDO->init ($addl_libs);

if (!defined $output_file || $output_file eq '-') {
    $output = STDOUT;
}

STDERR->autoflush(1);
STDOUT->autoflush(1);

my ($doc_object) = Text::GDO->load_doc_object ('file' => $file)
    || die "$::prog: could not load document object, exiting\n";

foreach $output_type (split (/[,]/, $output_type)) {
    my ($args);

    $output_type =~ m/^(\w+)(\((.*)\))?/;
    ($output_type, $args) = ($1, $3);
    $output_instance = $doc_object->to ($output_type, 'args' => $args)
	|| die "$::prog: could not output document\n";

    if (!defined $output_file || $output_file eq '-') {
	$output_instance->stdout;
    } else {
	$output_instance->write ($output_file);
    }
}

exit;

# --- Emacs stuff ---
# Local Variables:
# mode:perl
# End:
