# -*- perl -*-
#
# Copyright (C) 1996 Ken MacLeod
# See the file COPYING for distribution terms.
#

# XXX doesn't work under 0.4

require "sroff-source.pl";
$outputType = "SROFF::RTF";
$extension = "rtf";

sub Check {
    system ">check-out";
    # no check for rtf
}

######################################################################
chop($expected{"dummy"} = <<'EOTEST');

EOTEST

######################################################################
chop($expected{"block-in-paragraph"} = <<'EOTEST');
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj DTD Fragments design uses sgmls to validate and parse the document instance (doesn't everybody :-), it then maps document entities to generalized entities that are implemented as object-methods.  A stack (single-line hierarchy) of object classes implements the methods, with the base-class being most general, and subsequent classes providing more detailed processing.  The SROFF example above looks like this internally:     \par
\pard\plain\fi0\li360\ri0\sa120\sb0\fs20\ql \keep\f22 Line 1\line Line 2\par
EOTEST

######################################################################
chop($expected{"links"} = <<'EOTEST');
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj {\b\fs36 1  Section One}\par
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj {\b\fs28 1.1  Section One.One}\par
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj {\b\fs24 1.1.1  Section One.One.One}\par
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj This links to Section One.Two.\par
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj {\b\fs24 1.1.2  Section One.One.Two}\par
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj This links to Section One.\par
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj {\b\fs28 1.2  Section One.Two}\par
EOTEST

######################################################################
chop($expected{"medium-paragraph"} = <<'EOTEST');
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj DTD Fragments design uses sgmls to validate and parse the document instance (doesn't everybody :-), it then maps document entities to generalized entities that are implemented as object-methods.  A stack (single-line hierarchy) of object classes implements the methods, with the base-class being most general, and subsequent classes providing more detailed processing.  The SROFF example above looks like this internally:\par
EOTEST

######################################################################
chop($expected{"noadjust"} = <<'EOTEST');
\pard\plain\fi0\li360\ri0\sa120\sb0\fs20\ql \keep some data\line       \lquote {\f22 quoted data}\rquote \par
\pard\plain\fi0\li360\ri0\sa120\sb0\fs20\ql \keep more data\line       \lquote {\f22 more quoted data}\rquote \par
EOTEST

######################################################################
chop($expected{"quoting"} = <<'EOTEST');
\pard\plain\fi0\li360\ri0\sa120\sb0\fs20\ql \keep\f22 some data\line       {\f22 quoted data}\par
\pard\plain\fi0\li360\ri0\sa120\sb0\fs20\ql \keep\f22 more data\line       {\f22 more quoted data}\par
EOTEST

######################################################################
chop($expected{"sections-titles"} = <<'EOTEST');
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj {\b\fs36 1  Section One}\par
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj {\b\fs28 1.1  Section One.One}\par
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj {\b\fs24 1.1.1  Section One.One.One}\par
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj {\b\fs24 1.1.2  Section One.One.Two}\par
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj {\b\fs28 1.2  Section One.Two}\par
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj {\b\fs36 2  Section Two}\par
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj {\b\fs28 2.1  Section Two.One}\par
EOTEST

######################################################################
chop($expected{"title-page"} = <<'EOTEST');
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj \qc{\b Test Title}\par
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj \qc{\b Test SubTitle}\par
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj \qc{\b Test Date}\par
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj \qc{\i Test Author}\par
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj \qc{\i ABSTRACT}\par
\pard\plain\fi0\li720\ri0\sa120\sb0\fs20\qj Test Abstract\par
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj Test Extra\par
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj Test Copyright\par
EOTEST

######################################################################
chop($expected{"url"} = <<'EOTEST');
\pard\plain\fi0\li0\ri0\sa120\sb0\fs20\qj Home of DTD Fragments (http://bitsko.slc.ut.us/)\par
EOTEST

######################################################################
chop($expected{"variable-list"} = <<'EOTEST');
\pard\plain\fi0\li0\ri0\sa0\sb0\fs20\qj \keepn term1a\par
\pard\plain\fi0\li0\ri0\sa0\sb0\fs20\qj \keepn term1b\par
\pard\plain\fi0\li720\ri0\sa120\sb0\fs20\qj Without PAR tag.\par
\pard\plain\fi0\li0\ri0\sa0\sb0\fs20\qj \keepn term2\par
\pard\plain\fi0\li720\ri0\sa120\sb0\fs20\qj With PAR tag, first paragraph.\par
\pard\plain\fi0\li720\ri0\sa120\sb0\fs20\qj Second paragraph.\par
EOTEST

$header = <<'EOTEST';
{\rtf1\deff16
{\fonttbl
{\f0\fswiss Chicago;}
{\f2\froman New York;}
{\f3\fswiss Geneva;}
{\f4\fmodern Monaco;}
{\f13\fnil Zapf Dingbats;}
{\f16\fnil Palatino;}
{\f20\froman Times;}
{\f21\fswiss Helvetica;}
{\f22\fmodern Courier;}
{\f23\ftech Symbol;}
}
{\stylesheet
{\s255\sb240 \b\f21\ul \sbasedon0\snext0 heading 1;}
{\s254\sb120 \b\f21 \sbasedon0\snext0 heading 2;}
{\s253\li360 \b \sbasedon0\snext0 heading 3;}
{\sa120 \sbasedon222\snext0 Normal;}
}
\sectd \linemod0\cols1
EOTEST
chop ($header);

for $key (keys %expected) {
    $expected{$key} = $header . $expected{$key} . "}\r";
}

1;
